function [k, p, err, P, GP] = bisect(f, a, b, tol)
% INPUT
% f - iterowana funkcja (podana w oddzielnym m-file'u)
% a - poczatek przedzialu
% b - koniec przedzialu
% tol - dokladnosc iteracji

% OUTPUT 
% k - numer iteracji przy ktorym osiagnieto zakladana dokladnosc
% p - obliczone miejsce zerowe
% err - osiagniety blad bezwzgledny
% P - wektor kolejnych wartoci punktow {pk}

ya= feval('f',a);
yb= feval('f',b);

%if ya*yb > 0, break, end
max1=1+round((log(b-a)-log(tol))/log(2))

for k=1:max1
    P(k)=(a+b)/2;
    GP(k)= feval('f',P(k));
    if GP(k)==0 
        a=P(k);
        b=P(k);
    elseif yb*GP(k) > 0
        b=P(k);
        yb=GP(k);
    else
        a=P(k);
        ya=GP(k);
    end
    if (b-a) < tol, break, end
end
P(k)=(a+b)/2;
p=P(k);
err=abs(b-a);
GP(k)=feval('f',p);
P=P';        
GP=GP';