function [k, p, err, P, GP] = fixpt(g, p0, tol, max1)
% INPUT
% g - iterowana funkcja (podana w oddzielnym m-file'u)
% p0 - startowy punkt iteracji
% tol - dokladnosc iteracji
% max1 - maksymalna liczna iteracji

% OUTPUT 
% k - numer iteracji przy ktorym osiagnieto zakladana dokladnosc
% p - obliczony punkt staly
% err - osiagniety blad bezwzgledny
% P - wektor kolejnych wartoci punktow {pk}

P(1)=p0;
GP(1)=p0-feval('g',P(1));
for k=2:max1
    P(k)=feval('g',P(k-1));
    err=abs(P(k)-P(k-1));
    relerr=err/(abs(P(k))+eps);
    GP(k)=P(k)-feval('g',P(k));
    p=P(k);
    if (err<tol) | (relerr<tol), break, end
end
if k==max1
    disp('Przekroczono maksymalna liczbe iteracji')
end
P=P';
GP=GP';