function [k, p, err, P, GP] = sieczne(f, p0, p1, delta, tol, max1)
% INPUT
% f - iterowana funkcja (podana w oddzielnym m-file'u)
% p0 - pierwszy punkt startowy
% p1 - drugi punkt startowy
% delta - dokadnosc wyznaczenia miejsca zerowego 
% tol - dokladnosc iteracji wartoci funkcji g(x)
% max1 - maksymalna liczba iteracji

% OUTPUT 
% k - numer iteracji przy ktorym osiagnieto zakladana dokladnosc
% p - obliczone miejsce zerowe
% err - osiagniety blad bezwzgledny
% P - wektor kolejnych wartoci punktow {pk}
% GP - wartosc funkcji g(x) w kolejnych przyblizeniach

P(1)=p0;
P(2)=p1;
GP(1)= feval('f',P(1));
GP(2)= feval('f',P(2));
for k=3:max1
    P(k)=P(k-1)-feval('f',P(k-1))*(P(k-1)-P(k-2))/(feval('f',P(k-1))-feval('f',P(k-2)));
    err=abs(P(k)-P(k-1));
    relerr=2*err/(abs(P(k))+delta);
    GP(k)= feval('f',P(k));
    if (err < delta) | (relerr < delta) | (abs(GP(k)) < tol), break, end
end
p=P(k);
GP(k)=feval('f',p);
P=P';        
GP=GP';